#define NO_FUNCTION_PTR

// *********************************************************************
// Function prototypes
// *********************************************************************
void usage(void);
void AddKeywords(void);
void GenerateSpasm(void);
void GetGlobalSymbols(void);
int LocateAssignment(int num, char **tokens);
int ProcessNonStore(int i, int num, char **tokens);
int ProcessStore(int i, int num, char **tokens, int assignpos);
int ProcessExpression(int i, int num, char **tokens, int prec, int action);
int ProcessLeftParen(int i, int num, char **tokens, int state);
void ProcessObject(int num, char **tokens);
void DumpSymbols(void);
void ErrorExit(void);
int ProcessKey(int i, int num, char **tokens, int state);
int ProcessRepeat(int i, int num, char **tokens, int state);
int ProcessCase(int i, int num, char **tokens, int state);
int ProcessIf(int i, int num, char **tokens, int state);
int ProcessElseIf(int i, int num, char **tokens, int state);
int ProcessElse(int i, int num, char **tokens, int state);
int ProcessQuit(int i, int num, char **tokens, int state);
int ProcessNext(int i, int num, char **tokens, int state);
int ProcessReturn(int i, int num, char **tokens, int state);
int ProcessAccess(int i, int num, char **tokens, int state);
int ProcessOp(int i, int num, char **tokens, int state);
int ProcessBinaryOp(int i, int num, char **tokens, int state);
int ProcessBinaryEqOp(int i, int num, char **tokens, int state);
int ProcessUnaryOp(int i, int num, char **tokens, int state);
int ProcessExtraOp(int i, int num, char **tokens, int state);
int ProcessAt(int i, int num, char **tokens, int state);
int ProcessFunction(int i, int num, char **tokens, int state, int intrinsic);
int ProcessCallObj(int i, int num, char **tokens, int state);
int ProcessPub(int i, int num, char **tokens, int state);
int ProcessIntrinsic(int i, int num, char **tokens, int state);
int ProcessValue(int i, int num, char **tokens, int state);
int ProcessRightBracket(int i, int num, char **tokens, int state);
int ProcessClkfreq(int i, int num, char **tokens, int state);
int ProcessPubStatement(int i, int num, char **tokens);
int ProcessLeftParen(int i, int num, char **tokens, int state);
int ProcessExpression(int i, int num, char **tokens, int prec, int action);
int ProcessCaseItem(int i, int num, char **tokens);
int ProcessStore(int i, int num, char **tokens, int assignpos);
int ProcessNonStore(int i, int num, char **tokens);
int CatchObject(int i, int num, char **tokens, int state);
int ProcessString(int i, int num, char **tokens, int state);

#ifdef NO_FUNCTION_PTR
int ExecuteFunction(int fFunction, int i, int num, char **tokens, int state);

// *********************************************************************
// Function indices
// *********************************************************************
#define fProcessValue         0
#define fProcessClkfreq       1
#define fProcessAccess        2
#define fProcessRepeat        3
#define fProcessKey           4
#define fProcessCase          5
#define fProcessIf            6
#define fProcessElseIf        7
#define fProcessElse          8
#define fProcessQuit          9
#define fProcessNext         10
#define fProcessReturn       11
#define fProcessBinaryOp     12
#define fProcessBinaryEqOp   13
#define fProcessOp           14
#define fProcessUnaryOp      15
#define fProcessAt           16
#define fProcessExtraOp      17
#define fProcessLeftParen    18
#define fProcessRightBracket 19
#define fProcessPub          20
#define fProcessIntrinsic    21
#define fProcessCallObj      22
#define fCatchObject         23
#define fProcessString       24
#else
// *********************************************************************
// Function pointers
// *********************************************************************
#define fProcessValue        ProcessValue
#define fProcessClkfreq      ProcessClkfreq
#define fProcessAccess       ProcessAccess
#define fProcessRepeat       ProcessRepeat
#define fProcessKey          ProcessKey
#define fProcessCase         ProcessCase
#define fProcessIf           ProcessIf
#define fProcessElseIf       ProcessElseIf
#define fProcessElse         ProcessElse
#define fProcessQuit         ProcessQuit
#define fProcessNext         ProcessNext
#define fProcessReturn       ProcessReturn
#define fProcessBinaryOp     ProcessBinaryOp
#define fProcessBinaryEqOp   ProcessBinaryEqOp
#define fProcessOp           ProcessOp
#define fProcessUnaryOp      ProcessUnaryOp
#define fProcessAt           ProcessAt
#define fProcessExtraOp      ProcessExtraOp
#define fProcessLeftParen    ProcessLeftParen
#define fProcessRightBracket ProcessRightBracket
#define fProcessPub          ProcessPub
#define fProcessIntrinsic    ProcessIntrinsic
#define fProcessCallObj      ProcessCallObj
#define fCatchObject         CatchObject
#define fProcessString       ProcessString
#endif

