#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "strsubs.h"

// SPIN OBJECT c : "clibos"
// SPIN OBJECT

#if 0
int toupper(int val)
{
    if (val >= 'a' and val <= 'z')
        val -= 32;
    return val;
}
#endif

int StrCompNoCase(char *str1, char *str2)
{
    while (*str1 && toupper((int)*str1) == toupper((int)*str2))
    {
	str1++;
	str2++;
    }
    return *str1 == *str2;
}

char *FindChar(char *str, int val)
{
    while (*str)
    {
	if (*str == val) break;
	str++;
    }
    return str;
}

char *SkipChars(char *str1, char *str2)
{
    char *str3;
    while (*str1)
    {
	str3 = FindChar(str2, *str1);
	if (*str3 == 0) break;
	str1++;
    }
    return str1;
}

char *FindChars(char *str1, char *str2)
{
    char *str3;
    while (*str1)
    {
	str3 = FindChar(str2, *str1);
	if (*str3) break;
	str1++;
    }
    return str1;
}

char *FindStr(char *str1, char *str2)
{
    int len = strlen(str2);
    while (*str1)
    {
	if (strncmp(str1, str2, len) == 0) break;
	str1++;
    }
    return str1;
}

static char *ops[] = {
    "++", "+=", "+", "--", "-=", "-", ">>=", ">>",
    ">-=", ">-", "><=", "><", ">|", ">=", ">", "<<=",
    "<<", "<-=", "<-", "<#=", "<#", "<>=", "<>", "<=",
    "<", "**=", "**", "*=", "*", "//=", "//", "/=",
    "/", "||", "|<", "|=", "|", "@@", "@", "#>=",
    "#>", "^^", "^=", "^", "=>=", "=>", "=<=", "=<",
    "!", "~~", "~>=", "~>", "~", "?", "===", "==", 0};

/* INLINE SPIN
PUB start | ptr
  ptr := @ops
  repeat while long[ptr]
    long[ptr] += @@0 - 16
    ptr += 4
*/

int FindList(char *str, char **list)
{
    int i=0;

    while (list[i])
    {
	if (strncmp(str, list[i], strlen(list[i])) == 0) return i;
	i++;
    }
    return -1;
}

int FindListNoCase(char *str, char **list)
{
    int i=0;

    while (list[i])
    {
	if (StrCompNoCase(str, list[i])) return i;
	i++;
    }
    return -1;
}

int GetTokens(char *str, char *str2, char **tokens)
{
    int len;
    int num = 0;
    char *str1;
    int j;

    while (*str)
    {
#ifndef CSPIN_FLAG
	str = SkipChars(str, " \t");
#endif
/* INLINE SPIN
str := SkipChars(str, string(" ", TAB_CHAR))
*/
	if (*str == 0) break;
	if (*str == SINGLE_QUOTE || *str == '{')
	{
	    len = strlen(str);
	    str1 = str + len;
	}
	else if (*str == DOUBLE_QUOTE)
	{
	    str1 = FindChar(str+1, DOUBLE_QUOTE);
	    if (*str1) str1++;
	    len = str1 - str;
	}
	else if ((j = FindList(str, ops)) >= 0)
	{
	    len = strlen(ops[j]);
	    str1 = str + len;
	}
	else
	{
#ifndef CSPIN_FLAG
            str1 = FindChars(str, " \t()[]@|,+-<>*/!^~?");
#endif

/* INLINE SPIN
str1 := FindChars(str, string(" ", TAB_CHAR, "()[]@|,+-<>*#/!^~?"))
*/
	    if (str == str1) str1++;
	    len = str1 - str;
	}
	//printf("len = %d\n", len);
	memcpy(str2, str, len);
	str2[len] = 0;
	tokens[num++] = str2;
	//printf("tokens[%d] = %s\n", num-1, str2);
	str2 += len + 1;
	str += len;
    }
    if (num > 1 && (tokens[num-1][0] == SINGLE_QUOTE || tokens[num-1][0] == '{'))
	num--;
    return num;
}

void RemoveCRLF(char *str)
{
    int len = strlen(str);

    str += len - 1;
    while (len > 0)
    {
	if (*str != 10 && *str != 13) break;
	*str-- = 0;
	len--;
    }
}
