'******************************************************************************
' Copyright (c) 2011, 2012, 2013 Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibos"
  sys : "sysdefs"

PUB main(argc, argv)
  c.enter
  if argc == 1
    c.printf1(string("%x\n"), long[sys#config])
  elseif argc == 2
    if strcomp(long[argv][1], string("-p"))
      print_config
    else
      set_config(long[argv][1])
  elseif argc == 3
    ifnot strcomp(long[argv][1], string("-p"))
      usage
    else
      set_config(long[argv][2])
      print_config
  else
    usage
  c.exit(0)

PUB print_config | config, width
  config := long[sys#config]
  c.printf1(string("config = %x\n"), config)
  c.printf0(string("Newline generates "))
  case config & 3
    0 : c.printf0(string("nothing\n"))
    1 : c.printf0(string("LF\n"))
    2 : c.printf0(string("CR\n"))
    3 : c.printf0(string("CR and LF\n"))
  c.printf0(string("Terminal type is "))
  case (config >> 4) & 3
    0 : c.printf0(string("dumb\n"))
    1 : c.printf0(string("PST\n"))
    2 : c.printf0(string("ANSI\n"))
    other :
        c.printf0(string("invalid\n"))
  c.printf1(string("Terminal height is %d lines\n"), (config >> 8) & 255)
  width := (config >> 16) & 255
  ifnot width
    width := 256
  c.printf1(string("Terminal width is %d characters\n"), width)

PUB set_config(ptr)
  c.sscanf1(ptr, string("%x"), sys#config)

PUB usage
  c.printf0(string("usage: config [-p] [hex_number]\n"))
  c.exit(1)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
