'*********************************************
'* Spin code generated by cspin version 0.82 *
'*********************************************

'******************************************************************************
' Copyright (c) 2014 Dave Hein
' See end of file for terms of use.
'******************************************************************************
' INLINE SPIN
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibos"


CON
  BUF_SIZE = 10000
  MAX_LINES = 1000

PUB start(argc, argv)
  c.enter
  main(argc, argv)
  c.exit(0)


VAR
  long bufptr

DAT
  reverse long 0
  numlines long 0

VAR
  long lineptr[MAX_LINES]

PUB RemoveCRLF(str) | len
  len := strsize(str)
  repeat while (len--)
    if (byte[str][len] <> 10 and byte[str][len] <> 13)
      quit
    byte[str][len] := 0

PUB sort(str, num) | i, j, temp, val
  i := 0
  repeat while (i < num - 1)
    j := i + 1
    repeat while (j < num)
      val := c.strcmp(long[str][i], long[str][j])
      if (reverse)
        val := -val
      if (val > 0)
        temp := long[str][i]
        long[str][i] := long[str][j]
        long[str][j] := temp
      j++
    i++

PUB ReadFile(infile)
  repeat while (c.fgets(bufptr, 200, infile))
    RemoveCRLF(bufptr)
    lineptr[numlines++] := bufptr
    bufptr += strsize(bufptr) + 1

PUB usage
  c.printf0(string("usage: sort [-r] [-h] [FILE]...\n"))
  c.exit(0)

PUB main(argc, argv) | i, size, infile, nfiles
  nfiles := 0
  bufptr := c.malloc(BUF_SIZE)
  if (not bufptr)
    c.printf0(string("Could not allocate file buffer\n"))
    c.exit(1)
  ' Process command line parameters
  i := 1
  repeat while (i < argc)
    if (byte[long[argv][i]][0] == "-")
      if (not c.strcmp(long[argv][i], string("-r")))
        reverse := 1
      elseif (not c.strcmp(long[argv][i], string("-h")))
        usage
      else
        c.printf1(string("Invalid option - %s\n"), @byte[long[argv][i]][1])
        c.exit(1)
    else
      nfiles++
    i++
  if (nfiles == 0)
    ReadFile(c.getstdin)
  else
    i := 1
    repeat while (i < argc)
      if (byte[long[argv][i]][0] == "-")
        i++
        next
      infile := c.fopen(long[argv][i], string("r"))
      if (not infile)
        c.printf1(string("%s: No such file or directory\n"), long[argv][i])
        c.exit(1)
      ReadFile(infile)
      c.fclose(infile)
      i++
  i := 1
  repeat while (i < argc)
    if (not c.strcmp(long[argv][i], string("-r")))
      reverse := 1
    else
      nfiles++
    i++
  sort(@lineptr, numlines)
  i := 0
  repeat while (i < numlines)
    c.printf1(string("%s\n"), lineptr[i])
    i++
  return 0

{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}

